﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Esimerkki12_8
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }


        Series sarja;
        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'kauppaDataSet.Tuotteet' table. You can move, or remove it, as needed.
            this.tuotteetTableAdapter.Fill(this.kauppaDataSet.Tuotteet);


       

        }

      

        private void piirräPainike_Click(object sender, EventArgs e)
        {
            
            
            //Seuraavaksi tarkistetaan onko sarjaa jo lisätty diagrammiin.
            //Jos on jo lisätyy, poistutaan metodista.
            int indeksi = diagrammi.Series.IndexOf("KalliitTuotteet");
            if (indeksi != -1)
                return;


            //Tässä sarja alustetaan ja sen nimeksi laitetaan "KalliitTuotteet".
            sarja = diagrammi.Series.Add("KalliitTuotteet");
            
            //sarja.XValueMember = kauppaDataSet.Tables["Tuotteet"].Columns["Nimi"].ToString();
            //sarja.YValueMembers = kauppaDataSet.Tables["Tuotteet"].Columns["Yksikköhinta"].ToString();

            //sarja.XValueMember =  tuotteetTableAdapter.GetData().Columns["Nimi"].ToString();
            //sarja.YValueMembers = tuotteetTableAdapter.GetData().Columns["Yksikköhinta"].ToString();


            //sarja.XValueMember = tuotteetTableAdapter.GetKalliitTuotteet().Columns["Nimi"].ToString();
            //sarja.YValueMembers = tuotteetTableAdapter.GetKalliitTuotteet().Columns["Yksikköhinta"].ToString();

           


            //Tässä sarjan diagrammityypiksi valitaan pylväs.
            sarja.ChartType = SeriesChartType.Column;
            
            //Tässä ilmoitetaan, että Y-arvot saa näyttää.
            sarja.IsValueShownAsLabel = true;
            
            //Tässä vaöitaan diagrammin väripaletti.
            sarja.Palette = ChartColorPalette.BrightPastel;
        

           //Tässä määritellään diagrammin otsikko.
            diagrammi.Titles.Add("Tuotteet & Yksikköhinnat");

            //Tässä määritellään diagrammin toisen alueen ensimmäisen
            //akselin (X) otsikko. 
            diagrammi.ChartAreas[1].Axes[0].Title = "Tuote";

            //Tässä määritellään diagrammin toisen alueen toisen
            //akselin (Y) otsikko. 
            diagrammi.ChartAreas[1].Axes[1].Title = "Hinta (€/kg)";

            //Tässä diagrammin esitystyyliksi valitaan kolmiulotteinen.
            diagrammi.ChartAreas[1].Area3DStyle.Enable3D = true;

            //Tässä diagrammin inklinaatioksi asetetaan 20 astetta.
            diagrammi.ChartAreas[1].Area3DStyle.Inclination = 20;

            //Tässä diagrammin rotaatioksi asetetaan 20 astetta.
            diagrammi.ChartAreas[1].Area3DStyle.Rotation = 30;

            //Tässä sarjan piirrustusalueeksi  valitaan diagrammin toinen alue. 
            sarja.ChartArea = diagrammi.ChartAreas[1].Name;

            //Seuraavassa käydään läpi tuotteetTableAdapter-taulukkoadapterin 
            //GetKalliitTuotteet()-metodin palauttaman taulukon (DataTable)
            //rivit ja ne lisätään sarjaan siten, että X-arvoksi valitaan Nimi-
            //sarakkeen arvot ja Y-arvoksi valitaan Yksikköhinta-sarakkeen arvot 
            for (int i = 0; i < tuotteetTableAdapter.GetKalliitTuotteet().Rows.Count; i++)
            {
                //Tässä lisätään pisteet sarjaan ja se piirretään.
                sarja.Points.AddXY(tuotteetTableAdapter.GetKalliitTuotteet().Rows[i]["Nimi"].ToString(), double.Parse(tuotteetTableAdapter.GetKalliitTuotteet().Rows[i]["Yksikköhinta"].ToString()));


               // sarja.Points.AddXY(tuotteetTableAdapter.GetData().Rows[i]["Nimi"].ToString(), double.Parse(tuotteetTableAdapter.GetData().Rows[i]["Yksikköhinta"].ToString()));
            }
        }

        
    }
}
