﻿//Seuraavassa otetaan tarvittavat kirjastot käyttöön.
//System.Windows.Forms-nimiavaruus sisältää Form-luokan
//ja System.Drawing-nimiavaruus sisältää Color-, Size- ja 
//Point-luokat.  
using System;
using System.Windows.Forms;
using System.Drawing;

//Tässä määritellään UusiIkkuna-luokka, joka on myös 
//Windows-ikkuna.
public class UusiIkkuna : Form
{
    public UusiIkkuna()
    {
        //Seuraavissa määritellään ikkunan joitakin
        //ominaisuuksia.
        this.Text = "Esimerkki 2-1";
        this.BackColor = Color.Blue;
        this.ClientSize = new Size(400, 250);
        this.Location = new Point(50, 50);

        //Tässä, luokalle lisätään tapahtumakäsittelijä, jonka 
        //nimi on UusiIkkuna_MouseClick, ja joka hoitaa hiiren 
        //napsauttamisen.
        this.MouseClick += new System.Windows.Forms.
        MouseEventHandler(this.UusiIkkuna_MouseClick);
    }

    //Seuraavassa määrittellään
    private void UusiIkkuna_MouseClick(object sender,
    MouseEventArgs e)
    {
        //Tässä määrätään mitä tulee tapahtua, kun 
        //ikkunaa napsautetaan.
        this.BackColor = Color.Yellow;
    }

    private void InitializeComponent()
    {
        this.SuspendLayout();
        // 
        // UusiIkkuna
        // 
        this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(128)))), ((int)(((byte)(255)))));
        this.ClientSize = new System.Drawing.Size(309, 207);
        this.Name = "UusiIkkuna";
        this.Text = "Esimerkki 2-1";
        this.Load += new System.EventHandler(this.UusiIkkuna_Load);
        this.ResumeLayout(false);

    }

    private void UusiIkkuna_Load(object sender, EventArgs e)
    {

    }
}

//Seuraavassa määritellään sovelluksen pääluokka.
static class Esimerkki2_1x
{
    //Seuraavassa määritellään pääluokan Main()-emtodi.
    [STAThread]
    static void Main()
    {
        //Tässä luodaan uusi ilmentymä UusiIkkuna-luokasta.
        Application.Run(new UusiIkkuna());
    }
}