﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki4_4
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }

        

        private void centerValintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä taustakuvan sommittluksi laitetaan Center, joka on
            //määritelty staattisena  arvona luokassa ImageLayout.
            this.BackgroundImageLayout = ImageLayout.Center;

            //Tässä kuvanSommittelu-GroupBox piilotetaan.
            kuvanSommitteluGroupBox.Visible = false;
        }

        private void noneValintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä taustakuvan sommittluksi laitetaan None, joka on
            //määritelty staattisena  arvona luokassa ImageLayout.
            this.BackgroundImageLayout = ImageLayout.None;

            //Tässä kuvanSommittelu-GroupBox piilotetaan.
            kuvanSommitteluGroupBox.Visible = false;
        }

     
        private void stertchValintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä taustakuvan sommittluksi laitetaan Stretch, joka on
            //määritelty staattisena  arvona luokassa ImageLayout.
            this.BackgroundImageLayout = ImageLayout.Stretch;

            //Tässä kuvanSommittelu-GroupBox piilotetaan.
            kuvanSommitteluGroupBox.Visible = false;
        }

        private void tileValintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä taustakuvan sommittluksi laitetaan Tile, joka on
            //määritelty staattisena  arvona luokassa ImageLayout.
            this.BackgroundImageLayout = ImageLayout.Tile;

            //Tässä kuvanSommittelu-GroupBox piilotetaan.
            kuvanSommitteluGroupBox.Visible = false;
        }

        private void zoomValintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä taustakuvan sommittluksi laitetaan Zoom, joka on
            //määritelty staattisena  arvona luokassa ImageLayout.
            this.BackgroundImageLayout = ImageLayout.Zoom;

            //Tässä kuvanSommittelu-GroupBox piilotetaan.
            kuvanSommitteluGroupBox.Visible = false;
        }

        private void kuva3Valintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä pääikkunan taustakuvaksi laitetaan Sunset. Huomaa, että 
            //taustakuvan päätettä ei tarvitse eikä saa kirjoittaa.
            this.BackgroundImage = Esimerkki4_4.Properties.Resources.Sunset;

            //Tässä taustaKuva-valintanappiryhmä piilotetaan.
            taustaKuvaGroupBox.Visible = false;

            //Tässä ikkunan otsikkoteksti muutetaan. 
            this.Text = "Napsauta ikkunaa saadaksesi valintanappiryhmät näkyviin.";
        }

        private void kuva2Valintanappi_CheckedChanged(object sender, EventArgs e)
        {
            //Tässä pääikkunan taustakuvaksi laitetaan Sunrise. Huomaa, että 
            //taustakuvan päätettä ei tarvitse eikä saa kirjoittaa.
            this.BackgroundImage = Esimerkki4_4.Properties.Resources.Sunrise;

            //Tässä taustaKuva-valintanappiryhmä piilotetaan.
            taustaKuvaGroupBox.Visible = false;

            //Tässä ikkunan otsikkoteksti muutetaan. 
            this.Text = "Napsauta ikkunaa saadaksesi valintanappiryhmät näkyviin.";
        }

        private void kuva1Valintanappi_CheckedChanged(object sender, EventArgs e)
        {

            //Tässä pääikkunan taustakuvaksi laitetaan Birds. Huomaa, että 
            //taustakuvan päätettä ei tarvitse eikä saa kirjoittaa.
            this.BackgroundImage = Esimerkki4_4.Properties.Resources.Birds;

            //Tässä taustaKuva-valintanappiryhmä piilotetaan.
            taustaKuvaGroupBox.Visible = false;

            //Tässä ikkunan otsikkoteksti muutetaan. 
            this.Text = "Napsauta ikkunaa saadaksesi valintanappiryhmät näkyviin.";
        }

        private void Paaikkuna_MouseClick(object sender, MouseEventArgs e)
        {
            taustaKuvaGroupBox.Visible = true;
            kuvanSommitteluGroupBox.Visible = true;

            this.Text = "Esimerkki 4-4";
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {

            //kuva1Valintanappi.Checked = false;
            //centerValintanappi.Checked = false;
            
           taustaKuvaGroupBox.Visible = true;
           kuvanSommitteluGroupBox.Visible = true;
            //centerValintanappi.Checked = false;
            //noneValintanappi.Checked = false;
            //stretchValintanappi.Checked = false;
            //tileValintanappi.Checked = false;

            //zoomValintanappi.Checked = false;
           



        }

       

       

       
    }
}
