﻿using System;
using System.Collections;


namespace Esimerkki5_3
{
    class SanaKirja
    {

        //Tässä luodaan hajautustaulu sanojen säilytystä varten.
        Hashtable sanaParit = new Hashtable();



        public SanaKirja(string[] sana, string[] merkitys)
        {
            //Seuraavassa sanaparit lisätään hajautstauluun-
            for (int laskuri = 0; laskuri < sana.Length; laskuri++)
                sanaParit.Add(sana[laskuri], merkitys[laskuri]);
        }

        public void lisaaSanapari(string sana, string merkitys)
        {
            //Tässä yksittäinen sanapari lisätään hajautustauluun.
            sanaParit.Add(sana, merkitys);
        }


        //Seuraavassa määritellään Sanat-ominaisuus, joka palauttaa
        //sanakirjan kaikki sanat.
        public string[] Sanat
        {
            get {

                //Tässä luodaan sanat-taulukko, joka on samankokoinen
                //kuin luokan hajautustaulu.
                string[] sanat = new string[sanaParit.Count];

            
                //Tässä hajautustaulun kaikki sanat kopioidaan sanat-taulukkoon.
                sanaParit.Keys.CopyTo(sanat, 0);

                //Tässä sanat lajitellaan aakkosjärjestykseen.
                Array.Sort(sanat);

                return sanat;
            }

        }



        //Seuraava metodi palauttaa sanan merkityksen. Jos sanaa ei löydy,
        //se palauttaa null-arvon.
        public string Merkitys(string sana)
        {
            //Tässä saadaan luettelo hajautustaulun hakuavaimista (keys).
            IDictionaryEnumerator luettelo = sanaParit.GetEnumerator();

             string merkitys = null;

            //Seuraavassa verrataan annettu sanaa hakuavaimiin ja
            //vertailun perusteella sanan merkitys haetaan.
             while (luettelo.MoveNext())
             {
                 if (luettelo.Key.Equals(sana))
                     merkitys = luettelo.Value.ToString();
             }

            return merkitys;
        }
    }
}
