﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Esimerkki5_4
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }


        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            //Tässä kotihakemistoksi asetetaan C:\Temp\Kirja\Kirja2010_OK\Esimerkit\.
            Directory.SetCurrentDirectory(@"C:\Temp\Kirja\Kirja2010_OK\Esimerkit");

            //Seuraavissa kuvalistaan lisätään kuvia. Käyttämällä Bitmap-luokan FromFile()-metodia
            //luodaan Bitmap-olioita kuvatiedostoista. Huomaa, että @-merkillä erikoismerkkien, 
            //(kuten kauttaviivan) merkitykset poistetaan.
            kuvaLista.Images.Add(Bitmap.FromFile(@"Esimerkit_luku5\Esimerkki5_4\Resources\Birds.png"));
            kuvaLista.Images.Add(Bitmap.FromFile(@"Esimerkit_luku5\Esimerkki5_4\Resources\Sunrise.png"));
            kuvaLista.Images.Add(Bitmap.FromFile(@"Esimerkit_luku5\Esimerkki5_4\Resources\Sunset.png"));


            //Tässä pääikkunan taustakuvan sommitteluksi laitetaan Stretch, joka
            //löytyy luettelosta ImageLayout.
            this.BackgroundImageLayout = ImageLayout.Stretch;

        }


        //Tässä määritellään globaalimuuttuja laskuri.
        int laskuri = 0;

        private void kuvanKiertoPainike_Click(object sender, EventArgs e)
        {
            //Seuraavassa varmistetaan, ettei laskurin arvo pysyy
            //sallituissa rajoissa.
            if (laskuri == kuvaLista.Images.Count)
                laskuri = 0;

            //Tässä pääikkunan taustakuvaksi laitetaan kuva
            //kuvalistasta. Huomaa, kuinka Images-kokoelman kautta
            //listan sisältöön viitataan.    
            this.BackgroundImage = kuvaLista.Images[laskuri];

            //Tässä laskurin arvo lisätään yhdellä.
            laskuri++;
        }
    }
}
