﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.AccessControl;
using System.Security.Permissions;

namespace Esimerkki6_2
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }



        private void TulostaHakemistonSisalto(TreeNode solmu, string polku)
        {
            //Tässä haetaan lista hakemiston alla olevista tiedostoista.
            string[] tiedostot = Directory.GetFiles(polku);

            //Seuraavassa jokaisen tiedoston nimi lisätään solmuun.
            foreach (string tiedosto in tiedostot)
                solmu.Nodes.Add(tiedosto);

            //Tässä haetaan lista hakemiston alla olevista alihakemistoista.
            string[] hakemistot = Directory.GetDirectories(polku);


            //Seuraavissa ensin jokaisesta hakemistosta luodaan TreeNode-olio
            //ja sitten kutsutaan metodi rekurssiiviseti siten, että
            //ensimmäisenä argumenttina on TreeNode-olio ja toisena argumenttina
            //on hakemiston polku.
            foreach (string hakemisto in hakemistot)
            {
                TreeNode aliSolmu = new TreeNode(hakemisto);
                solmu.Nodes.Add(aliSolmu);
                TulostaHakemistonSisalto(aliSolmu, hakemisto);
            }
        }


        private void TulostaSolmu(TreeNode solmu)
        {


        }

        TreeView tempTreeView;

        private void Paaikkuna_Load(object sender, EventArgs e)
        {

            tempTreeView = new TreeView();
          tempTreeView.Nodes.Add("X");


           TreeNode juuriSolmu = new TreeNode(@"\");
              kopioTreeView.Nodes.Add(juuriSolmu.Text);

            


           // juuriSolmu.Expand();



        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Text = "" + hakemistoTreeView.Nodes[2].FullPath;
            this.Text += hakemistoTreeView.Tag;
        }


        //Tässä määritellään perusteksti hakemistoSisaltoLipuke:lle.
        //Tätä tekstiä käytetään, kun halutaan alustaa lipukkeen teksti.
        string hakemistoSisaltoLipukeTeksti = "Hakemistosisältö: ";

        private void hakemistoTekstikentta_KeyUp(object sender, KeyEventArgs e)
        {

            //Tässä selvitetään onko Enter-näppäintä painettu.
            if (e.KeyCode.Equals(Keys.Enter))
            {
                //Tässä ohjeteksti pyyhitään pois.
                ohjeLipuke.Text = "";

              
                //Tässä selvitetään juurihakemiston polku.
                string juuriHakemisto = hakemistoTekstikentta.Text;

                //Tässä varmistetaan, että solmuLaskurin arvo on nolla.
                solmuLaskuri = 0;

                //Tässä hakemistoSisaltoLipuke:n tekstiksi laitetaan perusteksti
                //ilman hakemiston sisällön lukumäärää, jotta voidaan uuden
                //hakemiston sisällön ilmaiseva luku ilmoittaa oikein.
                hakemistoSisaltoLipuke.Text = hakemistoSisaltoLipukeTeksti;

               
                //Seuraavissa tarkisteaan onko käyttäjän antama hakemisto olemassa.
                //Jos se ei ole olemassa, ohjeLipuke:n tekstiksi laitetaan sopiva teksti
                //ja poistutaan metodista.  
                if (!Directory.Exists(hakemistoTekstikentta.Text))
                {
                    ohjeLipuke.ForeColor = Color.Red;
                    ohjeLipuke.Text = hakemistoTekstikentta.Text + " ei ole olemassa!";

                    return;
                }

                
                //Tässä puunäkymän hakemistoTreeView vanha sisältö poistetaan.
                hakemistoTreeView.Nodes.Clear();

                //Tässä luodaan TreeNode-olio juuriSolmu, jonka teksti on käyttäjän
                //syöttämän hakemistoTekstikentta:n teksti.
                TreeNode juuriSolmu = new TreeNode(hakemistoTekstikentta.Text);

                //Tässä juuriSolmu lisätään puunäkymään.
                hakemistoTreeView.Nodes.Add(juuriSolmu);

                //Tässä kutsutaan TulostaHakemistonSisalto()-metodi, jolla hakemiston
                //sisältö selvitetään.
                TulostaHakemistonSisalto(hakemistoTreeView.Nodes[0], hakemistoTekstikentta.Text);

                //Tässä puurakenteen solmujen lukumäärä lasketaan.
                LaskeSolmut(hakemistoTreeView.Nodes[0]);

                //Tässä solmujen lukumäärä liitetään hakemistoSisaltoLipuke:n tekstiin.
                hakemistoSisaltoLipuke.Text = hakemistoSisaltoLipuke.Text + " " + solmuLaskuri;

                //Tässä  puurakenne levitetään näkyviin.
                juuriSolmu.Expand();

            }
        }

      
        // Adds an ACL entry on the specified directory for the specified account.
        public static void AddDirectorySecurity(string FileName, string Account, FileSystemRights Rights, AccessControlType ControlType)
        {
            // Create a new DirectoryInfo object.
            DirectoryInfo dInfo = new DirectoryInfo(FileName);

            // Get a DirectorySecurity object that represents the 
            // current security settings.
            DirectorySecurity dSecurity = dInfo.GetAccessControl();
          //  DirectorySecurity dierctorySecurity  = Directory.GetAccessControl(

            // Add the FileSystemAccessRule to the security settings. 
            dSecurity.AddAccessRule(new FileSystemAccessRule(Account, Rights, ControlType));

            // Set the new access settings.
            dInfo.SetAccessControl(dSecurity);

        }

       
        private void hakemistoTreeView_AfterCheck(object sender, TreeViewEventArgs e)
        {

            //Tässä tarkistetaan onko valittu solmu ruksittu (checked).
            if (e.Node.Checked)
            {
                //Tässä luodaan TreeNode-olio solmu, johon kopioidaan 
                //valittu solmu.
                TreeNode solmu = (TreeNode)e.Node.Clone();
                
                //Tässä ruksi poistetaan solmusta.
                solmu.Checked = false;

                //Tässä varmistetaan, että kopioitavaa solmua ei ole
                //kopioitu jo. Jos solmua ei ole kopioitu, se kopioidaan
                //kopioTreeView-puunäkymään.
                if (!kopioTreeView.Nodes[0].Nodes.Contains(solmu))

                    //Tässä ensin saadaan viittaus kopioTreeView-puunäkymän
                    //juurisolmun kokoelmaan ja sitten siihen lisätään uusi
                    //solmu.
                    kopioTreeView.Nodes[0].Nodes.Add(solmu);

                //Tässä kopioTreeView-puunäkymän puurakenne
                //levitetään näkyviin.
                kopioTreeView.ExpandAll();
              
            }
        }


   

   

     


        private void TulostaSolmu(TreeNode solmu, TreeNode alisolmu)
        {

               solmu.Nodes.Add(alisolmu.Text);

            if(alisolmu.Nodes.Count >0)
                foreach (TreeNode ttn in alisolmu.Nodes)
                    TulostaSolmu(alisolmu, ttn);
           
        }


        private void VaihdaSolmujenTila(TreeNode solmu, Color vari)
        {
              //Seuraavissa solmun valintaruudun ruksi poistetaan ja
              //solmun taustaväriski laitetaan argumenttina annettu väri.
              solmu.Checked = false;
              solmu.BackColor = vari;
              
             //Seuraavassa solmun jokaista alisolmua varten kutsutaan
             //metodi rekursiivisesti.
                foreach (TreeNode alisolmu in solmu.Nodes)
                    VaihdaSolmujenTila(alisolmu, vari);
        }



        private bool EtsiEka(TreeNode solmu, string teksti)
        {
            bool loytynyt = false;

            if (solmu.Text.Contains(teksti))
            {

                hakuLaskuri++;
                solmu.BackColor = Color.Blue;
               // textBox1.Text += solmu.Text + Environment.NewLine;
                hakemistoTreeView.TopNode = solmu;
                loytynyt = true;
                // hakemistoTreeView.TopNode.BackColor = Color.Yellow;
            }

            if (solmu.Nodes.Count > 0)
                foreach (TreeNode alisolmu in solmu.Nodes)
                    EtsiSolmu(alisolmu, teksti);

            return loytynyt;
        }




        private  void EtsiSolmu(TreeNode solmu, string teksti)
        {

            //Seuraavassa tarkistetaan sisältääkö solmun nimi
            //annettu teksti. Jos se sisältää, hakulaskurin arvoa
            //korotetaan ja sen valintaruutu ruksitaan.
            if (solmu.Text.Contains(teksti))
            {
                //Tässä hakuLaskuri:n arvo korotetaan yhdellä. 
                hakuLaskuri++;

                //Tässä solmun taustaväri muutetaan.
                solmu.BackColor = Color.Blue;

                //Täss solmu ruksitaan.
                solmu.Checked = true;

                //Tässä löydetty solmu laitetaan puunäkymän päällimmäiseksi
                //solmuksi.
                hakemistoTreeView.TopNode = solmu;
            }
              
               //Seuraavassa solmun jokaista alisolmua varten 
              //kutsutaan metodi rekursiivisesti.
                foreach (TreeNode alisolmu in solmu.Nodes)
                    EtsiSolmu(alisolmu, teksti);
        }

      

        private void PoistaKopioiSolmu(TreeNode solmu, string teksti)
        {

            if (!solmu.Text.Contains(teksti))
            {

                hakuLaskuri++;
                tempTreeView.Nodes[0].Nodes.Add(solmu);
                //textBox1.Text += solmu.Text + Environment.NewLine;
               // hakemistoTreeView.TopNode = solmu;
                // hakemistoTreeView.TopNode.BackColor = Color.Yellow;
            }

            if (!solmu.Text.Contains(teksti) && solmu.Nodes.Count > 0)
                foreach (TreeNode alisolmu in solmu.Nodes)
                {
                    solmu.Nodes.Add(alisolmu);
                    PoistaKopioiSolmu(alisolmu, teksti);

                }
        }


      
        private void PoistaSolmu(TreeNode solmu, string teksti)
        {

            TreeNode seuraavaSolmu = null;
            if (solmu != null && solmu.NextNode != null)
            {
                seuraavaSolmu = solmu.NextNode;
               // richTextBox1.Text += seuraavaSolmu.Text + " ";

            }
            if (solmu!=null && solmu.Text.Contains(teksti))
            {
              //  seuraavaSolmu = solmu.NextNode;
                
                solmu.Remove();
                hakuLaskuri++;
                //poistoLaskuri++;
            }


            if (solmu != null && solmu.Nodes.Count > 0)
                foreach (TreeNode alisolmu in solmu.Nodes)
                    PoistaSolmu(alisolmu, teksti);

            if (seuraavaSolmu != null)
                PoistaSolmu(seuraavaSolmu, teksti);

        }

        private void PoistaValittuSolmu(TreeNode solmu, string teksti)
        {

            if (solmu != null && solmu.BackColor.Equals(Color.Blue))
            {
                solmu.Remove();
                hakuLaskuri++;
                //poistoLaskuri++;
            }

            if (solmu != null && solmu.Nodes.Count > 0)
                foreach (TreeNode alisolmu in solmu.Nodes)
                    PoistaSolmu(alisolmu, teksti);
        }




        //Tässä määritellään globaalimuuttuja solmuLaskuri
        int solmuLaskuri = 0;
        private void LaskeSolmut(TreeNode solmu)
        {
            //Tässä solmuLaskurin arvoa korotetaan yhdellä- 
            solmuLaskuri++;

            
            //Seuraavassa puurakenteen jokainen solmu käydään läpi
            //ja jokaista solmua varten metodi kutsuu itsensä
            //rekursiivisesti.
               foreach (TreeNode alisolmu in solmu.Nodes)
                    LaskeSolmut(alisolmu);
        }




        //Tässä määritellään globaalimuuttuja hakuLaskuri.
        int hakuLaskuri;

        private void hakuPainike_Click(object sender, EventArgs e)
        {

            //Tässä varmistetaan, että hakuLaskuri:n arvo on alussa nolla. 
            hakuLaskuri = 0;

            //Seuraavassa tarkistetaan onko hakusana annettu vai ei.
            //Jos hakusanaa ei ole annettu, tulostetaan ilmoitus asiasta
            //hakuPalauteLipuke:lla.
            if (hakuTekstikentta.Text.Equals(""))
            {
                hakuPalauteLipuke.ForeColor = Color.Red;
                hakuPalauteLipuke.Text = "Hakusana puuttuu!";
            }
            else
            {
              
                //Tässä tarkistetaan onko puunäkymässä kopioTreeView solmuja. 
                if (kopioTreeView.Nodes.Count > 0)
                {
                    //Tässä kutsutaan VaihdaSolmujenTila()-metodi, jolla solmujen
                    // valintaruuduista poistetaan ruksita ja niiden taustaväriksi
                    //muutetaan samaksi kuin puunäkymän taustaväri. Näin poistetaan
                    //aikaisempien hakujen jäljet.
                    VaihdaSolmujenTila(kopioTreeView.Nodes[0], kopioTreeView.BackColor);

                    //Tässä tarkistetaan onko poistoValintaRuutu ruksittu vai ei.
                    if (poistoValintaRuutu.Checked)
                    {

                        //Tässä kutsutaan EtsiSolmu()-metodi, joka etsii ja ruksii
                        //hakuehdon täyttävän solmun valintaruudun.
                        EtsiSolmu(kopioTreeView.Nodes[0], hakuTekstikentta.Text);

                        //Tässä kutsutaan PoistaValitutSolmut()-metodi, joka poistaa solmut,
                        //joiden valintaruutu on ruksittu. Metodi PoistaValitutSolmut() palauttaa
                        //sen argumenttina olevasta puurakenteesta version, johon ei kuulu aiemmin
                        //ruksitut solmut.
                        TreeNode uusiSolmu=PoistaValitutSolmut(kopioTreeView.Nodes[0]);

                        //Tässä poistetaan puunäkymän kopioTreeView kaikki solmut.
                        kopioTreeView.Nodes.Clear();

                        //Tässä puunäkymään kopioTreeView lisätään uusiSolmu, joka ei
                        //sisällä poistokriteerin täyttäneitä solmuja.
                        kopioTreeView.Nodes.Add(uusiSolmu);

                        //Tässä puunäkymä kopioTreeView levitetään näkyviin.
                        kopioTreeView.ExpandAll();
                        
                        //Tässä asetetaan ilmoituslipukkeen tekstiväriksi keltainen.
                        hakuPalauteLipuke.BackColor=Color.Yellow;
                    }
                    else
                    {
                        //Jos kyseessä on haku eikä poisto, etsitään puunäkymästä
                        //halutut solmut kutsumalla EtsiSolmu()-metodi.
                        EtsiSolmu(kopioTreeView.Nodes[0], hakuTekstikentta.Text);

                        //Tässä asetetaan ilmoituslipukkeen tekstiväriksi sininen.
                        hakuPalauteLipuke.BackColor = Color.Blue;
                    }
                }
                
            }


            //Tässä ilmoitetaan haku- tai poistokriteerin täyttäneiden solmujen lukumäärä.
            hakuPalauteLipuke.Text = hakuLaskuri + " osuma(a) haulle: " + hakuTekstikentta.Text;
  
        }



        private void hakemistoTekstikentta_TextChanged(object sender, EventArgs e)
        {
            ohjeLipuke.ForeColor = Color.Red;
            ohjeLipuke.Text = "Kirjoita polku ja paina Enter!";
        }


        
        private void tulostaHakemistoPainike_Click(object sender, EventArgs e)
        {
            solmuLaskuri = 0;
            hakemistoSisaltoLipuke.Text = hakemistoSisaltoLipukeTeksti;

            hakemistoTreeView.Nodes.Clear();
            TreeNode juuriSolmu = new TreeNode(hakemistoTekstikentta.Text);
            hakemistoTreeView.Nodes.Add(juuriSolmu);

            TulostaHakemistonSisalto(hakemistoTreeView.Nodes[0], hakemistoTekstikentta.Text);


            LaskeSolmut(hakemistoTreeView.Nodes[0]);
            hakemistoSisaltoLipuke.Text = hakemistoSisaltoLipuke.Text + " " +  solmuLaskuri;


            juuriSolmu.Expand();


        }

        private void hakemistoTreeView_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if(e.Node.Checked)
               hakemistoTreeView.Nodes.Remove(e.Node);
        }

        private void varmuusTreeView_AfterSelect(object sender, TreeViewEventArgs e)
        {

        }

        private void varmuusTreeView_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {

          //  MessageBox.Show("" + e.Clicks);
            //if(e.Node.Parent !=null)
            //     e.Node.Remove();
        }

        private void hakemistoTreeView_BeforeCheck(object sender, TreeViewCancelEventArgs e)
        {
            //Tässä varmistetaan, että solmu, jonka valintatilaa muutetaan
            //on ennestään ruksittu. Näin poistetaan vain solmut, jotka ennen
            //valintatilan vaihtoa on ruksittu.
            if (e.Node.Checked)

                //Tässä hakemistoTreeView-puunäkymästä poistetaan solmu, jolta
                //ruksi on poistettu.
                hakemistoTreeView.Nodes.Remove(e.Node);
        }

        private void varmuusTreeView_AfterCheck(object sender, TreeViewEventArgs e)
        {
            //if (e.Node.Checked && e.Node.Parent!=null)
               
            //        //textBox1.Text += tn[0].Text + " " + varmuusTreeView.Nodes.Contains(tn[0]);
            //        kopioTreeView.Nodes.Remove(e.Node);
               
        }

        private void poistoValintaRuutu_CheckedChanged(object sender, EventArgs e)
        {
            if(poistoValintaRuutu.Checked)
                hakuPainike.Text = "Poista";
            else
                hakuPainike.Text = "Hae";
        }

        private void hakemistoTekstikentta_MouseEnter(object sender, EventArgs e)
        {
            ohjeLipuke.ForeColor = Color.Red;
            ohjeLipuke.Text = "Kirjoita polku ja paina Enter!";
        }


        private TreeNode iterate(TreeNode tn1, TreeNode tn2)
        {

           TreeNode tempTreeNode = new TreeNode(tn1.Text);

            // TreeNode ttn = new TreeNode();


            foreach (TreeNode tn in tn1.Nodes)
            {

                tempTreeNode.Nodes.Add(tn.Text);
                foreach(TreeNode ttn in tn.Nodes)
                  iterate(ttn, tn2);
            }

            tn2.Nodes.Add(tempTreeNode.Text);

            return tn2;

        }



        private TreeNode GetTreeNode(TreeNode tn)
        {

            TreeNode temp=new TreeNode(tn.Text);
            foreach (TreeNode ttn in tn.Nodes)
                temp.Nodes.Add((TreeNode)GetTreeNode(ttn).Clone());

            return temp;


        }



        private TreeNode PoistaValitutSolmut(TreeNode solmu)
        {
            //Tässä luodaan uusi solmu, jonka teksti on sama
            //kuin solmu;n teksti.
            TreeNode uusiSolmu = new TreeNode(solmu.Text);

            //Seuraavassa käydään jokaisen solmun alisolmut läpi.
            //Jos alisolmu on ruksittu, sitä ei oteta uuteen puusolmuun
            //(TreeNode) mukaan.
            foreach (TreeNode aliSolmu in solmu.Nodes)
            {
                if (aliSolmu.Checked)
                    continue;

                //Tässä metodin argumentiksi laitetaan aliSolmu.
                solmu = aliSolmu;

                //Tässä uuteen solmuun lisätään alisolmut. Alisolmujen 
                //lisääminen tapahtuu kutsumalla metodi rekursiivisesti.
                uusiSolmu.Nodes.Add(PoistaValitutSolmut(solmu));
            }

            //Tässä rakennettu uusiSolmu palautetaan.
            return uusiSolmu;
        }




        private void KopioiValitutSolmutx(TreeNode tn1, TreeNode  tn2)
        {

             TreeNode tempSolmu =null;
             TreeNode tempAliSolmu = null;
             TreeNode tempAliAliSolmu = null;

          
             tempSolmu = new TreeNode(tn1.Text);
             foreach (TreeNode tn in tn1.Nodes)
             {
                // KopioiValitutSolmut(tn, tn2);
                 
                    tempAliSolmu = new TreeNode(tn.Text);


                    foreach (TreeNode ttn in tn.Nodes)
                    {

                        tempAliAliSolmu = new TreeNode(ttn.Text);

                        foreach (TreeNode tttn in ttn.Nodes)

                            tempAliAliSolmu.Nodes.Add(tttn.Text);

                        tempAliSolmu.Nodes.Add((TreeNode)tempAliAliSolmu.Clone());

                  

                        //                 tempSolmu.Nodes.Add((TreeNode)tempAliSolmu.Clone());

                    }

                    tempSolmu.Nodes.Add((TreeNode)tempAliSolmu.Clone());

                 //tempAliSolmu = new TreeNode(tn.Text);
                 //KopioiValitutSolmut(ttn, tn2);
             }

             tn2.Nodes.Add((TreeNode)tempSolmu.Clone());


             //for (TreeNode tn = tn1.LastNode; tn.Equals(tn1.FirstNode); tn=tn1.NextNode) 
             //TreeNode tn = tn1.FirstNode;
        //    while(!tn.Equals(tn1.LastNode))
            {
                //tv.Nodes.Add(tn.Text);

                //string[] nodeContent = new string[tn.Nodes.Count];
                //tn.Nodes.CopyTo(
                //foreach(string str in nodeContent)
                  //tempTreeNode.Nodes.Add(tn.Text);
                 // tn = tn1.NextNode;

              // KopioiValitutSolmut(tn, tn2);
              //  tn2.Nodes.Add(tn.Text);
            }

         //   tn2 = tempTreeNode;
          // tn2.TreeView.Nodes.Add((TreeNode)tempTreeNode.Clone());
          
            //foreach (TreeNode tn in tn1.Nodes)
            //{

            //    KopioiValitutSolmut(tn, tv);

            //}
         

       




            //tv.Nodes.Add((TreeNode)tempTreeNode.Clone());





            //foreach (TreeNode tn in tn1.Nodes)
            //{
            //    //tempTreeNode.Nodes.Add((TreeNode)tn.Clone());
            //    if(!tn.Checked)
            //    tn2.Nodes.Add((TreeNode)tn.Clone());

            //}

//           foreach(TreeNode tn in tn1.Parent.Nodes



               // KopioiValitutSolmut(tn, tn2);
                    //MessageBox.Show("Blue color");
                    // tv2.Nodes.Add((TreeNode)tn.Clone());
                //    tv2.Nodes[0].Nodes.Add((TreeNode)tn.Clone());
               


            //foreach (TreeNode tn in tv1.Nodes[0].Nodes)
            //    if (tn.Checked)
            //    {
            //        //MessageBox.Show("Blue color");
            //        // tv2.Nodes.Add((TreeNode)tn.Clone());
            //        tv2.Nodes[0].Nodes.Add((TreeNode)tn.Clone());
            //    }

            




            //foreach(TreeNode tn in klone.Nodes)
            //    if (tn.BackColor.Equals(Color.Blue))
            //    {
            //        // tv2.Nodes.Add((TreeNode)tn.Clone());
            //        tv2.Nodes[0].Nodes.Add(tn);
            //    }
            //foreach (TreeNode tn in tv1.Nodes)
            //{
            //    tv2.Nodes.Add(tn);
            //     //foreach(TreeNode tttn1 in ttn1.Nodes)
            //     //    tn2.Nodes


            //}



        }



        private void button1_Click_1(object sender, EventArgs e)
        {
            //hakemistoTreeView.Nodes[0].Nodes.Clear();
            //hakemistoTreeView.Nodes[0] = new TreeNode("x");
            hakemistoTreeView.Nodes.Clear();
            hakemistoTreeView.Nodes.Add(kopioTreeView.Nodes[0].Text);
            hakemistoTreeView.Nodes.Clear();
         //   PoistaValitutSolmut(kopioTreeView.Nodes[0], hakemistoTreeView.Nodes[0]);
        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            
            hakemistoTreeView.Nodes.Clear();
        
            //hakemistoTreeView.Nodes.Add(KopioiValitutSolmutX(kopioTreeView.Nodes[0]));
  

        }

        private void button2_Click(object sender, EventArgs e)
        {
            kopioTreeView.Nodes[0].Nodes.Clear();
        }

        private void button1_Click_3(object sender, EventArgs e)
        {
            VaihdaSolmujenTila(kopioTreeView.Nodes[0], Color.Azure);
        }

     
    }
}
