﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkit_luku7
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }

       
 
        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            webSelain.Url = new Uri("http://www.suomi.fi");
        }

        private void Paaikkuna_Resize(object sender, EventArgs e)
        {

            Size uusiKoko = new Size(this.ClientRectangle.Width - 20, this.ClientRectangle.Height - 50);
            webSelain.Size = uusiKoko;
        }

        private void edellinenPainike_Click(object sender, EventArgs e)
        {
            webSelain.GoBack();
        }

        private void seuraavaPainike_Click(object sender, EventArgs e)
        {
            webSelain.GoForward();
        }

        private void homePainike_Click(object sender, EventArgs e)
        {
           
            webSelain.GoHome();
  
        }

       
      private void hakuTekstikentta_KeyUp(object sender, KeyEventArgs e)
        {
            if (!string.IsNullOrEmpty(hakuTekstikentta.Text) && e.KeyCode.Equals(Keys.Enter))
            {

                Uri UriToNavigate = new Uri(string.Format("http://www.google.com/search?q={0}", hakuTekstikentta.Text));
                webSelain.Navigate(UriToNavigate);

               
            
            }
        }
            

        


        private void webSelain_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {

            if (suosikkiLista.Items.IndexOf(webSelain.Document.Url.ToString()) == -1)
            {
                suosikkiLista.Items.Add(webSelain.Document.Url.ToString());
                suosikkiLista.Text = webSelain.Document.Url.ToString();
            }
          
        }

        private void suosikkiLista_KeyUp(object sender, KeyEventArgs e)
        {
            if (!string.IsNullOrEmpty(suosikkiLista.Text) && e.KeyCode.Equals(Keys.Enter))
            {

                if (!suosikkiLista.Text.StartsWith("http://") && !suosikkiLista.Text.StartsWith("https://") && !suosikkiLista.Text.StartsWith("file://"))
                    suosikkiLista.Text = "http://" + suosikkiLista.Text;

                webSelain.Navigate(suosikkiLista.Text);
            }
        }

        private void suosikkiLista_SelectedIndexChanged(object sender, EventArgs e)
        {
            webSelain.Url = new Uri(suosikkiLista.SelectedItem.ToString());
        }

      
  
    }
}
