﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;

namespace Esim11_1
{
    public partial class Form1 : Form
    {

        // Declare the PrintDocument object.
        //private PrintDocument docToPrint =
        //    new PrintDocument();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

       

        // This method will set properties on the PrintDialog object and
        // then display the dialog.
        private void Button1_Click(System.Object sender,
            System.EventArgs e)
        {

           

        }

        // The PrintDialog will print the document
        // by handling the document's PrintPage event.
        private void document_PrintPage(object sender,
            System.Drawing.Printing.PrintPageEventArgs e)
        {

            // Insert code to render the page here.
            // This code will be called when the control is drawn.

            // The following code will render a simple
            // message on the printed document.
            string text = "In document_PrintPage method.";

            System.Drawing.Font printFont = new System.Drawing.Font
                ("Arial", 35, System.Drawing.FontStyle.Regular);

            // Draw the content.
            e.Graphics.DrawString(richTextBox1.Text, printFont,
                System.Drawing.Brushes.Black, 10, 10);
        }

        private void button1_Click_1(object sender, EventArgs e)
        {

    
            // Allow the user to choose the page range he or she would
            // like to print.
            PrintDialog1.AllowSomePages = true;

            // Show the help button.
            PrintDialog1.ShowHelp = true;

            // Set the Document property to the PrintDocument for 
            // which the PrintPage Event has been handled. To display the
            // dialog, either this property or the PrinterSettings property 
            // must be set 
            PrintDialog1.Document = printDocument1;

            DialogResult result = PrintDialog1.ShowDialog();

            // If the result is OK then print the document.
            if (result == DialogResult.OK)
            {
                printDocument1.Print();
            }
        }

        private void printPreviewDialog1_Load(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            InitializePrintPreviewControl();
        }



        // Declare the PrintPreviewControl object and the 
        // PrintDocument object.
        internal PrintPreviewControl PrintPreviewControl1;
        private System.Drawing.Printing.PrintDocument docToPrint =
            new System.Drawing.Printing.PrintDocument();

        private void InitializePrintPreviewControl()
        {

            // Construct the PrintPreviewControl.
            this.PrintPreviewControl1 = new PrintPreviewControl();

            // Set location, name, and dock style for PrintPreviewControl1.
            this.PrintPreviewControl1.Location = new Point(88, 80);
            this.PrintPreviewControl1.Name = "PrintPreviewControl1";
            this.PrintPreviewControl1.Dock = DockStyle.Fill;

            // Set the Document property to the PrintDocument 
            // for which the PrintPage event has been handled.
            this.PrintPreviewControl1.Document = docToPrint;

            // Set the zoom to 25 percent.
            this.PrintPreviewControl1.Zoom = 0.25;

            // Set the document name. This will show be displayed when 
            // the document is loading into the control.
            this.PrintPreviewControl1.Document.DocumentName = "c:\\someFile";

            // Set the UseAntiAlias property to true so fonts are smoothed
            // by the operating system.
            this.PrintPreviewControl1.UseAntiAlias = true;

            // Add the control to the form.
            this.Controls.Add(this.PrintPreviewControl1);

            // Associate the event-handling method with the
            // document's PrintPage event.
            this.docToPrint.PrintPage +=
                new System.Drawing.Printing.PrintPageEventHandler(
                docToPrint_PrintPage);
        }

        // The PrintPreviewControl will display the document
        // by handling the documents PrintPage event
        private void docToPrint_PrintPage(
            object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {

            // Insert code to render the page here.
            // This code will be called when the control is drawn.

            // The following code will render a simple
            // message on the document in the control.
            string text = "In docToPrint_PrintPage method.";
            System.Drawing.Font printFont =
                new Font("Arial", 35, FontStyle.Regular);

            e.Graphics.DrawString(text, printFont,
                Brushes.Black, 10, 10);
        }

    }









}
