﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esim11_2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }


        // Declare the PrintPreviewControl object and the 
        // PrintDocument object.
        internal PrintPreviewControl PrintPreviewControl1;
        private System.Drawing.Printing.PrintDocument docToPrint =
            new System.Drawing.Printing.PrintDocument();

        private void InitializePrintPreviewControl()
        {

            // Construct the PrintPreviewControl.
            this.PrintPreviewControl1 = new PrintPreviewControl();

            // Set location, name, and dock style for PrintPreviewControl1.
            this.PrintPreviewControl1.Location = new Point(88, 80);
            this.PrintPreviewControl1.Name = "PrintPreviewControl1";
            this.PrintPreviewControl1.Dock = DockStyle.Fill;

            // Set the Document property to the PrintDocument 
            // for which the PrintPage event has been handled.
            this.PrintPreviewControl1.Document = docToPrint;

            // Set the zoom to 25 percent.
            this.PrintPreviewControl1.Zoom = 0.25;

            // Set the document name. This will show be displayed when 
            // the document is loading into the control.
            this.PrintPreviewControl1.Document.DocumentName = @"c:\temp\README.txt";

            // Set the UseAntiAlias property to true so fonts are smoothed
            // by the operating system.
            this.PrintPreviewControl1.UseAntiAlias = true;

            // Add the control to the form.
            this.Controls.Add(this.PrintPreviewControl1);

            // Associate the event-handling method with the
            // document's PrintPage event.
            this.docToPrint.PrintPage +=
                new System.Drawing.Printing.PrintPageEventHandler(
                docToPrint_PrintPage);
        }

        // The PrintPreviewControl will display the document
        // by handling the documents PrintPage event
        private void docToPrint_PrintPage(
            object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {

            // Insert code to render the page here.
            // This code will be called when the control is drawn.

            // The following code will render a simple
            // message on the document in the control.
        //    string text = "In docToPrint_PrintPage method.";

           // string text = richTextBox1.Text;

            string text = rtx.Text;
            System.Drawing.Font printFont =
                new Font("Arial", 35, FontStyle.Regular);

            e.Graphics.DrawString(text, printFont,
                Brushes.Black, 10, 10);
        }


        RichTextBox rtx = new RichTextBox();
        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog().Equals(DialogResult.OK))
            {
                rtx.LoadFile(openFileDialog1.FileName, RichTextBoxStreamType.RichText);
                InitializePrintPreviewControl();
            }
          //  richTextBox1.Hide();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {

        }


    }
}
