﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace Esimerkki4_2
{
    public partial class PaaIkkuna : Form
    {
        public PaaIkkuna()
        {
            InitializeComponent();
        }

        private void latausPainike_Click(object sender, EventArgs e)
        {

            //Tässä kutsutaan RichTextBox-olion LoadFile()-metodi, joka vaatii ladattavan 
            //tiedoston polun sekä tiedostotyypin.
            richTiedostoTekstiKentta.LoadFile(nimiTekstikentta.Text, RichTextBoxStreamType.RichText);

            //Tässä avataan lukuvirta luettavaan tiedostoon File-luokan
            //OpenText()-metodilla, joka vaatii tiedoston polun. Tiedoston
            //polku saadaa nimiTekstikenttan sisällöstä.   
            StreamReader sr = File.OpenText(nimiTekstikentta.Text);

            //Tässä tiedostoTekstiKentta:n sisältö alustetaan lukemalla
            //lukuvirta loppuun.  
            tiedostoTekstiKentta.Text = sr.ReadToEnd();
            
            //Tässä lukuvirta suljetaan. Huomaa, että kaikki virrat pitää
            //sulkea käytön jälkeen. Muuten ne voisi aiheuttaa odottamattomia
            //ongelmia esim. estämällä niiden uudelleen avaamisen.
            sr.Close(); 
        }

        private void tallennusPainike_Click(object sender, EventArgs e)
        {

           // richTiedostoTekstiKentta.SaveFile(@"C:\Temp\Arkisto\Muokattu.rtf");

            //Tässä richTiedostoTekstiKentta:n sisältö tallennetaan tiedostoon,
            //jonka polku ja nimi löytyy nimiTekstiKentan tekstistä.
            richTiedostoTekstiKentta.SaveFile(nimiTekstikentta.Text);

            //Tässä olisi toinen tapa antaa tiedoston polku ja nimi. Huomaa,
            //että @-merkillä ennen merkkijonoa kääntäjälle imoitetaan, ettei
            //saa merkkijonossa olevia merkkejä kuten \ saa tulkita muulla tavalla. 
            //richTiedostoTekstiKentta.SaveFile(@"C:\Temp\Arkisto\Muistio.rtf");


            //Seuraavassa olisi tapa, jolla voitaisiin 
            //tiedostoTekstiKentta:n sisältö tallenntaa
            //esim. tiedostoon Muistio.txt. Huomaa taas, että jos ei
            //kirjoiteta @-merkkiä ennen merkkijonoa, joudutaan
            //kaikki \-merkit polussa kirjoittamaan tuplasti näin: \\.
            //File.WriteAllText(@"C:\Temp\Arkisto\Muistio.txt", tiedostoTekstiKentta.Text);
        }

        private void lopetusPainike_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        //private void richTiedostoTekstiKentta_TextChanged(object sender, EventArgs e)
        //{
        //    //Seuraavassa sender-olio muunnetaan RichTextBox-olioksi ja
        //    //sitten sen taustaväriä muutetaan.
        //    //RichTextBox aktiiviTekstikentta = (RichTextBox)sender;
        //    //aktiiviTekstikentta.BackColor = Color.Cornsilk;


        //    //Seuraavassa olisi toinen tapa muuttaa halutun
        //    //tekstikentän taustaväriä.
        //    richTiedostoTekstiKentta.BackColor = Color.Cornsilk;
        //}

        //Tässä esitellään Random-olio.
        Random random;

        private void richTiedostoTekstiKentta_VScroll(object sender, EventArgs e)
        {

            //Tässä random-oli alustetaan. 
            random = new Random();

            //Tässä tekstikentän fontin väriä muutetaan satunnaisesti
            //kutsumalla random-olion Next()-metodi, joka geneori satunnaisesti kokonaislukuja
            //0-255 välillä. 
            richTiedostoTekstiKentta.ForeColor = Color.FromArgb(random.Next(256), random.Next(256), random.Next(256));
        }


     

        private void putsausPainike_Click(object sender, EventArgs e)
        {
            //Tässä richTiedostoTekstiKentta:n sisältö putsataan.
            richTiedostoTekstiKentta.Text = "";

            //Tässä tiedostoTekstiKentta:n sisältö putsataan.
            tiedostoTekstiKentta.Text = "";
        }

  
      

  
    }
}
