﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki2_8
{
    public partial class PaaIkkuna : Form
    {
        public PaaIkkuna()
        {
            InitializeComponent();
        }


        //Seuraavissa esitellään kolme Form-oliota, joita myöhemmin alustetaan.
        Form punainenIkkuna = null;
        Form vihreaIkkuna = null;
        Form sininenIkkuna = null;



        //private void NaytaIkkuna(Form ikkuna, Color vari, int siirto)
        //{
        //    //Tässä luodaan uusi ikkuna.
        //    punainenIkkuna = new Form();

        //    //Tässä määritellään ikkunan otsikko.
        //    punainenIkkuna.Text = "Punainen" + " ikkuna";

        //    //Tässä määritellään uuden ikkunan taustaväri.
        //    punainenIkkuna.BackColor = Color.Red;

        //    //Tässä uusi ikkuna oikeasti näytetään. Huomaa, että ilman
        //    //seuraavaa riviä uutta ikkunaa ei nähdä!
        //    punainenIkkuna.Show();

        //    //Tässä määritellään uuden ikkunan sijainti pääikkunan sijainnin mukaan.
        //    punainenIkkuna.Location = new Point(this.Location.X + 50, this.Location.Y + 70);


        //}



        private void ikkunatCheckedListBox_SelectedIndexChanged(object sender, EventArgs e)
        {

            //Seuraavassa selvitetään tapahtuman lähettäjä
            //muuntamalla sender-olio.
            CheckedListBox aktiiviLista = (CheckedListBox)sender;
            

             string valittu="";

            //Tässä selvitetään valittu listan jäsen SelectedItem()-metodilla,
            //joka palauttaa valitun jäsenen object-oliona. Tästä syystä 
            //joudutaan suorittamaan tyyppimuunos ToString()-metodilla. 
            if(aktiiviLista.SelectedItem !=null)
               valittu = aktiiviLista.SelectedItem.ToString();

            //Seuraavassa selvitetään valittu-merkkijonon arvo ja 
            //sitä mukaa luodaan ja näytetään oikeanvärinen ikkuna. 
            switch (valittu)
            {

                case "Punainen ikkuna":
                  

                    //Tässä tarkistetaan onko listan ensimmäisenä jäsenenä oleva 
                    //valintaruutu Checked-tilassa vai ei GetItemCheckState(0)-metodilla. 
                    if (ikkunatCheckedListBox.GetItemCheckState(0).Equals(CheckState.Checked))
                    {
                        //if (punainenIkkuna != null && !punainenIkkuna.IsDisposed)
                        //    punainenIkkuna.Dispose();

                        //Tässä luodaan uusi ikkuna.
                        punainenIkkuna = new Form();

                        //Tässä määritellään ikkunan otsikko.
                        punainenIkkuna.Text = "Punainen ikkuna";

                        //Tässä määritellään uuden ikkunan taustaväri.
                        punainenIkkuna.BackColor = Color.Red;

                        //Tässä uusi ikkuna oikeasti näytetään. Huomaa, että ilman
                        //seuraavaa riviä uutta ikkunaa ei nähdä!
                        punainenIkkuna.Show();

                        //Tässä määritellään uuden ikkunan sijainti pääikkunan sijainnin mukaan.
                        punainenIkkuna.Location = new Point(this.Location.X + 50, this.Location.Y + 70);
                    }

                        //Tässä tarkistetaan onko valintaruudun tila jokin muu kuin Checked.
                        //Jos on, sitten ikkuna hävitetään.
                       else if (ikkunatCheckedListBox.GetItemCheckState(0).Equals(CheckState.Indeterminate) || ikkunatCheckedListBox.GetItemCheckState(0).Equals(CheckState.Unchecked))
                    
                    {
                        //Tässä tarkistetaan onko uusIkkuna alustettu. Tämä on erittäin tärkeä!
                        //Jos uusIkkunaa ei ole alustettu, ts. sen arvo on null, sille ei saa
                        //tehdä mitään!  
                        if (punainenIkkuna != null)
                        {

                            punainenIkkuna.Close();

                            //Tässä uusiIkkuna hävitetään ja sen varaamat resurssit
                            //vapautetaan.
                            punainenIkkuna.Dispose();

                           
                        }
             

                    }                
                   
                    break;

                case "Vihreä ikkuna":

                    //Tässä tarkistetaan onko listan ensimmäisenä jäsenenä oleva 
                    //valintaruutu Checked-tilassa vai ei GetItemCheckState(1)-metodilla. 
                    if (ikkunatCheckedListBox.GetItemCheckState(1).Equals(CheckState.Checked))
                    {
                        //Tässä luodaan uusi ikkuna.
                        vihreaIkkuna = new Form();

                        //Tässä määritellään ikkunan otsikko.
                        vihreaIkkuna.Text = "Vihreä ikkuna";

                        //Tässä määritellään uuden ikkunan taustaväri.
                        vihreaIkkuna.BackColor = Color.Green;

                        //Tässä uusi ikkuna oikeasti näytetään. Huomaa, että ilman
                        //seuraavaa riviä uutta ikkunaa ei nähdä!
                        vihreaIkkuna.Show();

                        //Tässä määritellään uuden ikkunan sijainti pääikkunan sijainnin mukaan.
                        vihreaIkkuna.Location = new Point(this.Location.X + 70, this.Location.Y + 90);
                    }

                        //Tässä tarkistetaan onko valintaruudun tila jokin muu kuin Checked.
                    //Jos on, sitten ikkuna hävitetään.
                    else if (ikkunatCheckedListBox.GetItemCheckState(1).Equals(CheckState.Indeterminate) || ikkunatCheckedListBox.GetItemCheckState(1).Equals(CheckState.Unchecked))
                    {
                        //Tässä tarkistetaan onko uusIkkuna alustettu. Tämä on erittäin tärkeä!
                        //Jos uusIkkunaa ei ole alustettu, ts. sen arvo on null, sille ei saa
                        //tehdä mitään!  
                        if (vihreaIkkuna != null)
                        {

                            //Tässä uusiIkkuna hävitetään ja sen varaamat resurssit
                            //vapautetaan.
                            vihreaIkkuna.Dispose();
                        }


                    }  


                    break;


                case "Sininen ikkuna":

                    //Tässä tarkistetaan onko listan ensimmäisenä jäsenenä oleva 
                    //valintaruutu Checked-tilassa vai ei GetItemCheckState(2)-metodilla. 
                    if (ikkunatCheckedListBox.GetItemCheckState(2).Equals(CheckState.Checked))
                    {
                        //Tässä luodaan uusi ikkuna.
                        sininenIkkuna = new Form();

                        //Tässä määritellään ikkunan otsikko.
                        sininenIkkuna.Text = "Sininen ikkuna";

                        //Tässä määritellään uuden ikkunan taustaväri.
                        sininenIkkuna.BackColor = Color.Blue;

                        //Tässä uusi ikkuna oikeasti näytetään. Huomaa, että ilman
                        //seuraavaa riviä uutta ikkunaa ei nähdä!
                        sininenIkkuna.Show();

                        //Tässä määritellään uuden ikkunan sijainti pääikkunan sijainnin mukaan.
                        sininenIkkuna.Location = new Point(this.Location.X + 90, this.Location.Y + 110);
                    }

                        //Tässä tarkistetaan onko valintaruudun tila jokin muu kuin Checked.
                    //Jos on, sitten ikkuna hävitetään.
                    else if (ikkunatCheckedListBox.GetItemCheckState(2).Equals(CheckState.Indeterminate) || ikkunatCheckedListBox.GetItemCheckState(2).Equals(CheckState.Unchecked))
                    {
                        //Tässä tarkistetaan onko uusIkkuna alustettu. Tämä on erittäin tärkeä!
                        //Jos uusIkkunaa ei ole alustettu, ts. sen arvo on null, sille ei saa
                        //tehdä mitään!  
                        if (sininenIkkuna != null)
                        {

                            //Tässä uusiIkkuna hävitetään ja sen varaamat resurssit
                            //vapautetaan.
                            sininenIkkuna.Dispose();
                        }


                    }  

                    break;

            }


        }


        private void kopiointiPainike_Click(object sender, EventArgs e)
        {

            //Seuraavassa ensin tarkistetaan onko varaCheckedListBox tyhjä
            //vai ei. Jos on, sitten kopiointi suoritetaan. 
            if(varaCheckedListBox.Items.Count==0)
            {
                //Tässä varaCheckedListBox-listan tekstin vääriksi
                //laitetaan DarkCyan.
                varaCheckedListBox.ForeColor = Color.DarkCyan;

                //Tässä ensin ikkunatCheckedListBox-listan sisältö luetaan
                //Items-ominaisuudella ja sitten se lisätään varaCheckedListBox-
                //listaan AddRange()-metodilla. 
                varaCheckedListBox.Items.AddRange(ikkunatCheckedListBox.Items);
            }
            //this.varaCheckedListBox.SelectedIndexChanged += new System.EventHandler(this.varaCheckedListBox_SelectedIndexChanged);
        }

        private void poistoPainike_Click(object sender, EventArgs e)
        {

     
            if (varaCheckedListBox.Items.Count != 0)
            varaCheckedListBox.Items.Clear();
        }

        private void varaCheckedListBox_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void varaCheckedListBox_MouseDoubleClick(object sender, MouseEventArgs e)
        {

            if (varaCheckedListBox.Items.Count != 0)
              varaCheckedListBox.Items.RemoveAt(varaCheckedListBox.SelectedIndex);

            //if (varaCheckedListBox.Items.Count == 0)
            //    kopioitu = false;
        }

       

        
    }
}
