﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Tehtava5_5
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }

        private void kopiointiPainike_Click(object sender, EventArgs e)
        {

            foreach(object obj in tyontekijatListBox.SelectedItems)
            valitutTyontekijatCheckedListBox.Items.Add(obj);
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            tyontekijatListBox.DisplayMember = "Nimi";
            tyontekijatListBox.ValueMember = "ID" + " " + "Palkka" ;

            tyontekijatListBox.Items.Add(new Tyontekija("John", 100, 234.56));
            tyontekijatListBox.Items.Add(new Tyontekija("Alicia", 200, 534.56));
            tyontekijatListBox.Items.Add(new Tyontekija("Shiva", 300, 834.56));


        }


        
        private void lisaysPainike_Click(object sender, EventArgs e)
        {

            //if (nimiTekstikentta.Text.Equals(""))
            //    nimiTekstikentta.Text = "Kirjoita";
            //if(!tyontekijatListBox.Items.Contains(nimiTekstikentta.Text))
            //tyontekijatListBox.Items.Add(nimiTekstikentta.Text);

            char[] erottimet = new char[]{','};
            string[] attribuutit = nimiTekstikentta.Text.Split(erottimet);

            Tyontekija tyonTekija = new Tyontekija(attribuutit[0], Convert.ToInt16(attribuutit[1]), Convert.ToDouble(attribuutit[2]));

            tyontekijatListBox.Items.Add(tyonTekija);

            //foreach (string att in attribuutit)
            //    palauteLipuke.Text += att + " ";


        }

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if(e.CurrentValue.Equals(CheckState.Unchecked)){
              
                if (e.Index != 0)
                {
                    object valittu = valitutTyontekijatCheckedListBox.Items[e.Index - 1];
                    valitutTyontekijatCheckedListBox.Items[e.Index-1] = valitutTyontekijatCheckedListBox.Items[e.Index];
                    valitutTyontekijatCheckedListBox.Items[e.Index] = valittu;

                }

            }
        }
    }
}
