﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki8_1
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }

        private void Paaikkuna_Load(object sender, EventArgs e)
        {
           
        }

        private void kalenteri_DateChanged(object sender, DateRangeEventArgs e)
        {
            
            //Tässä haetaan kelenterista valitun välin alku- ja loppupäivän ja 
            //laitetaan valittuPaivamaara-lipukkeen tekstin arvoksi.
            valittuPaivamaara.Text = kalenteri.SelectionStart + "--" + kalenteri.SelectionEnd;
     
            //Tässä kalenterista valitun välin alkupäivämäärää verrataan päivämäärävalitsimesta
            //valittuun päivämäärään ja jos ne ovat samat. asiasta ilmoitetaan ilmoitusikkunalla. 
            if(kalenteri.SelectionStart.Equals(paivamaaraValistin.Value.Date))
               MessageBox.Show("Päivämäärät ovat samat", "Ilmoitus", MessageBoxButtons.OK, MessageBoxIcon.Information);
        
        }

    
        private void paivamaaraValistin_ValueChanged(object sender, EventArgs e)
        {
         
            //Tässä haetaan päivämäärävalitsimesta valittu arvo ja laitetaan
            //valittuPaivamaaraAika-lipukkeen tekstiksi.
            valittuPaivamaaraAika.Text = "" + ((DateTimePicker)sender).Value;

            //Seuraavassa selvitetään päivämäärävalitsimesta valittu kellon aika
            //ja sen perustella muutetaan pääikkunan taustaväriä.
            if (((DateTimePicker)sender).Value.Hour <= 12)
                this.BackColor = Color.LimeGreen;
            else
                this.BackColor = Color.OrangeRed;
        }

    
    }
}
