﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki8_3
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }


        
        private void ajastin_Tick(object sender, EventArgs e)
        {
            //Seuraavassa tarkistetaan onko edistyspalkki saavuttanut
            //maksimiarvonsa vai ei. Jos se on saavuttanut maksimiarvonsa,
            //se resetoidaan. Vastaavasti seuraavaksi näytettäävään kirjaimeen
            //viittaava laskuri nollataan ja otsikkoLipuke:n teksti poistetaan.
            if (edistysPalkki.Value >= edistysPalkki.Maximum)
            {
                edistysPalkki.Value = edistysPalkki.Minimum;
                laskuri = 0;
                otsikkoLipuke.Text = "";
            }

            else
            {
                //Tässä edistypalkin arvoa päivitetään siten, että siihen
                //lisätään sen Step-määre.
                edistysPalkki.PerformStep();

                //Tässä otsikkoLipuke:n tekstiin liitetään siihen
                //kuuluva seuraava kirjain.
                otsikkoLipuke.Text += otsikkoKirjaimet[laskuri++];


                //Seuraavassa selvitetään edistyspalkin arvo, joka myös laitetaan
                //lukuvalitsimen arvoksi.
                int lukuArvo = edistysPalkki.Value;
                lukuValitsin.Value = lukuArvo;

                
               //Tässä lukuvalitsimen taustaväriksi muutetaan sen arvon mukaan.
               lukuValitsin.BackColor = Color.FromArgb(125+lukuArvo,  255-lukuArvo , 255);
            }
        }


        //Seuraavassa määritellään muuttujat, joita käytetään ajastimen
        //ja otsikkoLipuke:n tekstin käsittelemiseksi.
        bool ajastinPaalla = false;
        int laskuri = 0;
        private void aloitusPainike_Click(object sender, EventArgs e)
        {

            //Seuraavassa otsikkoLipuke:n teksti poistetaan jos se
            //on jo kokonaan esillä.
            if(otsikkoLipuke.Text.Length==otsikonKoko)
               otsikkoLipuke.Text = "";

            //Seuraavassa tarkistetaan onko ajastin päällä vai ei. Jos
            //ajastin on päällä, se kytketään pois päältä ja painikkeen
            //tekstiä päivitetään sen mukaan. Jos taas ajastin ei ole päällä,
            //se kytketään päälle ja paianikkeen tekstiä muutetaan vastaavasti.
            if (ajastinPaalla)
            {
                ajastin.Stop();
                aloitusPainike.Text = "Aloita";
                ajastinPaalla = false;
               
            }
            else
            {
                ajastin.Start();
                aloitusPainike.Text = "Lopeta";
                ajastinPaalla = true;
               

            }
        }



        //Seuraavat muuttujat esitellään otsikossa olevien kirjainten
        //ja niiden lukumäärän säilyttämiseks.
        int otsikonKoko;
        char[] otsikkoKirjaimet;
        private void Paaikkuna_Load(object sender, EventArgs e)
        {
            //Tässä otsikkoLipuke:n teksti muunnetaan merkkitaulukoksi
            //ja viedään otsikkoKirjaimet-taulukkoon, joka on tyyppiä char.
            otsikkoKirjaimet = otsikkoLipuke.Text.ToCharArray();

            //Tässä selvitetään otsikkoLipuke:n tekstissä olevien 
            //kirjainten lukumäärä. 
            otsikonKoko = otsikkoLipuke.Text.Length;

            //Tässä edistyspalkin arvojen väliset etäisyydet lasketaan 
            //otsikkoLipuke:n tekstissä olevien kirjainten lukumäärän perusteella.
            edistysPalkki.Step = (int)(edistysPalkki.Maximum - edistysPalkki.Minimum) / otsikonKoko;

            //Tässä lukuvalitsiemn minimiarvoksi laitetaan sama, kuin
            //edistyspalkin minimiarvo.
            lukuValitsin.Minimum = edistysPalkki.Minimum;

            //Tässä tarkennetaan edistyspalkin maksimiarvo sen minimiarvon ja lasketun
            //etäisyyden perusteella.
            edistysPalkki.Maximum = edistysPalkki.Minimum + edistysPalkki.Step * otsikonKoko;

            //Tässä lukuvalitsiemn maximiarvoksi laitetaan sama, kuin
            //edistyspalkin maximiarvo.
            lukuValitsin.Maximum = edistysPalkki.Maximum;
        }

        private void lukuValitsin_ValueChanged(object sender, EventArgs e)
        {
           
            //Tässä edistyspalkin arvoksi laitetaan lukuvalitsimesta valittu arvo.
            edistysPalkki.Value = (int)lukuValitsin.Value;

        }

        private void edistysPalkki_Click(object sender, EventArgs e)
        {
            //Tässä tapahtuman tiedot välitetään tapahtumankäsittelijälle 
            //aloitusPainike_Click() tapahtuman hoitamiseksi.
            aloitusPainike_Click(sender, e);
        }

       

        

     
    }
}
