﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Esimerkki9_2
{
    public partial class Paaikkuna : Form
    {
        public Paaikkuna()
        {
            InitializeComponent();
        }

        private void toolStripTextBox1_KeyUp(object sender, KeyEventArgs e)
        {

        }

        private void aikaToolStripComboBox_Click(object sender, EventArgs e)
        {

        }

        private void aikaToolStripComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {

        }



        //Seuraavassa esitellään globaalimuuttujat, joilla käyttäjän
        //antama teksti jaetaan pienempiin osiin. 
        string[] sanat;
        char[] erotin;

        //Tässä määritellään lauseAjastinPaalla-globaalimuuttuja, jolla
        //lauseAjastimen toimintaa hallitaan.
        bool lauseAjastinPaalla = false;
      
        private void aloitusToolStripButton_Click(object sender, EventArgs e)
        {
            //Seuraavassa näytetään virheilmoits jos mitään aikaa ei ole valittu
            //työkalupalkin puodtusvalikosta.
            if (aikaToolStripComboBox.SelectedItem == null)
            {
                MessageBox.Show("Valitse aika työkalupalkin pudotusvalikosta!", "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }


             //Seuraavassa näytetään virheilmoits jos mitään tekstiä ei ole kirjoitettu
            //työkalupalkin tekstikenttään.
            if (string.IsNullOrEmpty(tekstiToolStripTextBox.Text))
            {
                MessageBox.Show("Kirjoita teksti työkalupalkin tekstikenttään!", "Virhe", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }


            //Tässä laitetaan lauseAjastimen tauon pituus millisekunteina.
           lauseAjastin.Interval = int.Parse(aikaToolStripComboBox.SelectedItem.ToString())*1000;
         

          //Tässä määritellään erotin -merkkitaulukko, jolla lause
          //rikotaan sanoiksi. 
           erotin = new char[] {' '};
          
            //Tässä työkalupalkin tekstikentän teksti rikotaan sanoiksi
            //annettujen erotinten mukaan.
            sanat = tekstiToolStripTextBox.Text.Split(erotin);

           //Seuraavassa työkalupalkin edistyspalkin askel- ja maksimi-arvo määritellään
            //lauseAjastimen taukopituuden ja annettun lauseen sanojen lukumäärän mukaan.
           edistysPalkkiToolStripProgressBar.Step = (int) (lauseAjastin.Interval / sanat.Length);
           edistysPalkkiToolStripProgressBar.Maximum = edistysPalkkiToolStripProgressBar.Step * sanat.Length;

           //Seuraavassa tarkistetaan onko lauseAjastin päällä vai ei. Jos se on päällä,
           //sanatRichTextBox-tekstikenttä tyhjennetään ja ajastimet kytketään pois
           //päältä ja muut muuttujat resetoidaan. Jos lauseAjastin ei ole päällä, tehdään vastaavat
           //alustukset ja lauseAjastin laitetaan päälle.
           if (lauseAjastinPaalla)
           {
               lauseAjastinPaalla = false;
               aloitusToolStripButton.Text = "Aloita";
               sanatRichTextBox.Text = "";
               sanaLaskuri = -1;
               edistysPalkkiToolStripProgressBar.Value = 0;
               lauseAjastin.Stop();
               sanaAjastin.Stop();
           }
           else
           {
               lauseAjastinPaalla = true;
               aloitusToolStripButton.Text = "Lopeta";
               sanatRichTextBox.Text = "";
               lauseAjastin.Start();
           }




        }


        //Tässä määritellään sanaLaskuri-muuttuja, jota käytetään 
        //sanat-taulukon läpikäymiseksi.  
        int sanaLaskuri = -1;

        //Tässä määritellään satunnaisLuku-olio, jolla voidaa generoida satunnaislukuja.
        Random satunnaisLuku = new Random();

        private void lauseAjastin_Tick(object sender, EventArgs e)
        {
            //Tässä sanaLaskuri-muuttujan arvoa lisätään yhdellä.
            sanaLaskuri++;


            //Seuraavassa tarkistetaan onko annetun lauseen kaikki sanat esitetty vai ei.
            //Jos on, tehdään tarvittavat alustukset, kytketään lauseAjastin pois päältä
            //ja poistutaan.
            if (sanaLaskuri >= sanat.Length)
            {
                sanaLaskuri = 0;
                sanaAjastin.Stop();
                edistysPalkkiToolStripProgressBar.Value = 0;

                //Seuraavill riveillä saadaan animaatio loppumaan kun
                //tekstin kaikki osat on esitetty kerran.
                //lauseAjastinPaalla = false;
                //lauseAjastin.Stop();
                //aloitusToolStripButton.Text = "Aloita";
                //return;
              
            }

         

            //Seuraavassa työkalupalkin edistyspalkki resetoidaan, kun se saa maksimiarvonsa.
            if (edistysPalkkiToolStripProgressBar.Value == edistysPalkkiToolStripProgressBar.Maximum)
                edistysPalkkiToolStripProgressBar.Value = 0;


            //Tässä sanatRichTextBox-tekstialueeseen liitetään annetun lauseen
            //seuraava sana ja erotin-taulukon ensimmäinen alkio.
            sanatRichTextBox.Text += sanat[sanaLaskuri]+ erotin[0];

            //Tässä työkalupalkin edistyspalkin arvoa päivitetään.
            edistysPalkkiToolStripProgressBar.PerformStep();


            //Tässä sanaAjastimen taukoväliksi määritellän 10:s osaksi
            //lauseAjastimen taukoväliksi.
            sanaAjastin.Interval = lauseAjastin.Interval / 10;

            //Tässä sanaAjastin kytketään päälle.
            sanaAjastin.Start();
        }

        //Seuraavassa määritellään joukko globaalimuuttujia, joita käytetään 
        //tekstin esittämiseen.
        Font sananFontti;
        int fontinKoko = 20;
        Color[] tekstiVarit = new Color[] { Color.Yellow, Color.Wheat, Color.Turquoise, Color.Teal, Color.IndianRed, Color.Lavender};
        Color tekstiVari;
        private void sanaAjastin_Tick(object sender, EventArgs e)
        {

            //Seuraavassa sanatRichTextBox-tekstistä valitaan teksti siten, että se alkaa
            //viimeksi lisätystä sanasta ja sen pituus on viimeksi lisätyn sanan pituus. 
            sanatRichTextBox.SelectionStart = sanatRichTextBox.Text.LastIndexOf(sanat[sanaLaskuri]);
            sanatRichTextBox.SelectionLength = sanat[sanaLaskuri].Length;

            //Tässä valittua tekstiä sisenntään niin, että sisennysmäärä on satunnainen.
            sanatRichTextBox.SelectionIndent = satunnaisLuku.Next(200);

            //Tässä valitaan satunnaisesti jokin väri tekstiVarit-taulukosta. 
            tekstiVari=tekstiVarit[satunnaisLuku.Next(tekstiVarit.Length)];

            //Tässä fontinKoko-muuttujan arvoa korotetaan kahdella yksiköllä.
            fontinKoko += 2;

            //Seuraavassa tarkistetaan onko fontinKoko-muuttujan arvo saavuttanut
            //maksimiarvonsa vai ei. Jos fontinKoko on saavuttanut maksimiarvonsa,
            //sanatRichTextBox-tekstialueen sisältö rikotaan sanoiksi siten, että 
            //erotin on välilyönti. Tämän jälkeen jokaiselle sanalle määritellään 
            //satunnaisesti oma fontti, väri ja sisennyksen määrä. Lopussa sanaAjastin
            //kytketään pois päältä.
            if (fontinKoko >= 40)
            {
                fontinKoko = 20;

                string[] sanatTaulukko = sanatRichTextBox.Text.Split(erotin);
                foreach (string sana in sanatTaulukko)
                {
                    sananFontti = new Font(new FontFamily("Courier New"), 20 + satunnaisLuku.Next(20), FontStyle.Bold);

                    sanatRichTextBox.SelectionStart = sanatRichTextBox.Text.IndexOf(sana);
                    sanatRichTextBox.SelectionLength = sana.Length;
                    sanatRichTextBox.SelectionFont = sananFontti;
                    sanatRichTextBox.SelectionColor = tekstiVarit[satunnaisLuku.Next(tekstiVarit.Length)];
                    sanatRichTextBox.SelectionIndent = satunnaisLuku.Next(200);
                }

                sanaAjastin.Stop();
            }


            //Seuraavassa sananFontti alustetaan uudelleen päivitetyllä fontinKoko-muuttujalla
            //ja se laitetaan tekstialueen valitun osan fontiksi.
            sananFontti= new Font(new FontFamily("Courier New"), fontinKoko, FontStyle.Bold);
            sanatRichTextBox.SelectionFont = sananFontti;

            //Tässä tekstialueen valitun tekstin väriksi laitetaan tekstiVari, jok on 
            //satunnaisesti valittu joukosta värejä. 
            sanatRichTextBox.SelectionColor = tekstiVari;
        }

       
       
        private void värillinenToolStripMenuItem_Click(object sender, EventArgs e)
        {

            //Seuraavassa tarkistetaan onko sanatRichTextBox-tekstialueen taustaväri valkoinen vai 
            //ei. Jos se on, taustaväriksi laitetaan jokin satunnainen väri ja Taustavärit-alavalikon
            //Värillinen-alkio merkitään valituksi. Jos taustaväri on jokin muu, kuin vaölkoinen, se
            //muutetaan valkoiseksi ja Värillinen-alkion kohdalla merkki poistetaan.
            if (sanatRichTextBox.BackColor.Equals(Color.White))
            {
                sanatRichTextBox.BackColor = Color.FromArgb(satunnaisLuku.Next(256), satunnaisLuku.Next(256), satunnaisLuku.Next(256));
                värillinenToolStripMenuItem.Checked = true;
            }
            else
            {
                sanatRichTextBox.BackColor = Color.White;
                värillinenToolStripMenuItem.Checked = false;
            }
        }

        private void taustavaritToolStripDropDownButton_Click(object sender, EventArgs e)
        {

        }
    }
}
